<?php
ini_set('display_errors',1);
/*
Plugin Name: HyperComments
Plugin URI: http://hypercomments.com/
Description: HyperComments - New dimension of comments. Hypercomments technology allows commenting a specific word or a piece of text. 
Version: 1.0.2
Author:  Alexandr Bazik, Dmitry Goncharov, Inna Goncharova
Author URI: http://hypercomments.com/
*/
define('HC_DEV',false);
define('HC_URL', 'http://hypercomments.com');
require_once(dirname(__FILE__) . '/export.php');
require_once(dirname(__FILE__) . '/HypercommentsWordPressApi.php');
define('WP_CONTENT_URL', get_option('siteurl') . '/wp-content');
define('HC_PLUGIN_URL', WP_CONTENT_URL . '/plugins/hypercomments');
define('HC_XML_PATH',$_SERVER['DOCUMENT_ROOT'].'/wp-content/uploads');
$hc_api = new HypercommentsWordPressApi();
function hc_request_handler() {
  
    global $post;
    global $wpdb;
    global $hc_api;
    
    if (function_exists('load_plugin_textdomain')) {
         load_plugin_textdomain('hypercomments', 'wp-content/plugins/hypercomments/locales');
    }

    if (!empty($_GET['hc_action'])) {
        switch ($_GET['hc_action']) {      
            case 'export_comments':           
                if (current_user_can('manage_options') && DISQUS_CAN_EXPORT) {                                   
                     require_once(dirname(__FILE__) . '/export.php');
                     $wxr = hc_export_wp();       
                     $file_name = time().'.xml';                    
                     $file_root = HC_XML_PATH.'/'.$file_name;
                     
                     $file_path = WP_CONTENT_URL.'/uploads/'.$file_name;
                     file_put_contents($file_root, $wxr);
                     $json_arr = array(
                         'service'         => 'wordpress',
                         'widget_id'    => get_option('hc_wid'),
                         'request_url' => $file_path,                      
                         'result_url'    => admin_url('index.php').'?hc_action=delete_xml&xml='.$file_name,
                         'result'           => 'success'
                     );                       
                     if($json_arr){
                        echo json_encode($json_arr);
                     }else{
                         echo json_encode(array('result'=>'success'));
                     }
                     die();
                }         
            break;   
            case 'save_wid':
                update_option('hc_wid', $_GET['wid']);
                update_option('hc_access', $_GET['access']);
                echo $_GET['access'];
                die();
            break;
            case 'delete_xml':
                if(isset($_GET['result']) && $_GET['result'] == 'success'){
                    $filename = HC_XML_PATH.'/'.$_GET['xml'];
                    unlink($filename);
                    return json_encode(array('result'=>'success'));
                }else{
                    return json_encode(array('result'=>'error'));
                }
                exit();
            break;
        }
    }

}


      
      
add_action('init', 'hc_request_handler');

function hc_admin_head(){
?>
<link rel='stylesheet' href='<?php echo HC_PLUGIN_URL;?>/css/hypercomments.css'  type='text/css' />
<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js"></script>
<?php
}
add_action('admin_head', 'hc_admin_head');
// действие при инсталяции плагина
function hc_active(){  
      update_option('hc_selector', '.hc_counter_comments');
}
// действие при деинсталяции плагина
function hc_delete(){  
     delete_option('hc_wid');
     delete_option('hc_access');
     delete_option('hc_selector');
}
register_deactivation_hook(__FILE__,'hc_delete');
register_activation_hook(__FILE__,'hc_active');
function hc_show_script() {      
      global $post; 
      $parse = parse_url($post->guid);
      $url = str_replace('https://','',str_replace('http://','',str_replace('www.','',str_replace($parse['host'], get_option('home'), $post->guid))));      
?>
<div id="hypercomments_widget"></div>
<script type="text/javascript">
var _hcp = _hcp || {};_hcp.widget_id = <?php echo get_option('hc_wid');?>;_hcp.widget = "Stream";_hcp.platform = "wordpress";
_hcp.language = "<?php echo hc_get_language();?>";_hcp.xid = "<?php echo $url?>";
<?php if(HC_DEV) echo '_hcp.hc_test=1;';?>
(function() { 
var hcc = document.createElement("script"); hcc.type = "text/javascript"; hcc.async = true;
hcc.src = ("https:" == document.location.protocol ? "https" : "http")+"://widget.hypercomments.com/apps/js/hc.js";
var s = document.getElementsByTagName("script")[0]; s.parentNode.insertBefore(hcc, s.nextSibling); 
})();
</script>
<?php
}

function hc_count_widget() {      
  if(!is_single()) {    
?>
<script type="text/javascript">
<?php if(HC_DEV) echo 'HCDeveloper = true';?>   
var _hcp = _hcp || {};_hcp.widget_id = <?php echo get_option('hc_wid');?>;_hcp.widget = "Bloggerstream";_hcp.selector='<?php echo get_option('hc_selector');?>';
_hcp.platform = "wordpress";_hcp.language = "<?php echo hc_get_language();?>";
<?php
      if(hc_enableParams()){
            echo '_hcp.enableParams=true;';
       }
 ?>
(function() { 
var hcc = document.createElement("script"); hcc.type = "text/javascript"; hcc.async = true;
hcc.src = ("https:" == document.location.protocol ? "https" : "http")+"://widget.hypercomments.com/apps/js/hc.js";
var s = document.getElementsByTagName("script")[0]; s.parentNode.insertBefore(hcc, s.nextSibling); 
})();
</script>
<?php
  }
}

// Вставка виджета
add_action('wp_footer', 'hc_count_widget');
add_filter('comments_template', 'hc_comments_template');
add_filter('comments_number', 'hc_comments_text');
add_filter('get_comments_number', 'hc_comments_number');
 
function hc_comments_template($value){   
   return dirname(__FILE__) . '/comments.php';
}

function hc_comments_number($count) {
    global $post;
    return $count;
}

function hc_comments_text($comment_text) {
    global $post;  
    $parse = parse_url($post->guid);
    $url =  str_replace($parse['scheme'].'://'.$parse['host'], get_option('home'), $post->guid);   
    return '<span class="hc_counter_comments" href="'.$url.'">'.$comment_text.'</span>'; 
}

// action function for above hook
function hc_admin_page() {
    // добавления подменю в раздел Параметры
    add_options_page('HyperComments', 'HyperComments', 8, 'hypercomments', 'hc_options_page');
}

// Отображает страницу для настроек
function hc_options_page() {
     if( $_POST['hc_form_counter_sub'] == 'Y' ) {
         update_option( 'hc_selector',  $_POST['hc_form_selector'] );
         echo '<div class="updated"><p><strong>Options saved</strong></p></div>';
     }
     include_once(dirname(__FILE__) . '/manage.php');
}

function hc_add_pages() {
     add_submenu_page(
         'edit-comments.php',
         'HyperComments',
         'HyperComments',
         'moderate_comments',
         'hypercomments',
         'hc_options_page'
     );
}
add_action('admin_menu', 'hc_add_pages', 10);

add_action('admin_notices', 'hc_messages');

function hc_messages() {
    $page = (isset($_GET['page']) ? $_GET['page'] : null);
    if ( !get_option('hc_wid') && $page != 'hypercomments') {
       echo '<div class="updated"><p><b>'.__('You must <a href="edit-comments.php?page=hypercomments">configure the plugin</a> to enable HyperComments.', 'hypercomments').'</b></p></div>';
    }
}

function hc_enableParams()
{
     global $wpdb;
     $results = $wpdb->get_results( "SELECT guid FROM $wpdb->posts WHERE post_type !='revision' AND post_status = 'publish' LIMIT 1");
     foreach ( $results as $result ) {
       $link = $result->guid;
     }
     return strstr($link,'?');
}

function hc_get_language()
{
    $local = get_locale();
    $local_lang = explode('_',$local);     
    return $local_lang[0];  
}

?>
